PROC GLOBAL

numeric maxNumberOperators = 120;

//alpha (300) controlFilename = "Z:\Info\armeniaControl.dat";
//alpha (300) namesFilename = "Z:\Info\armeniaNames.dat";
//alpha (300) entryProgram = "Z:\Program\Entry\EnterData.ent";
//alpha (300) keyerMenuProgram = "Z:\Program\Menus\Keyer Menu\keyerMenu.ent";
//alpha (300) verifierMenuProgram = "Z:\Program\Menus\Verifier Menu\verifierMenu.ent";
//alpha (300) optimizeProgram = "Z:\Program\Menus\Optimize Database\optimizeDatabase.bch";
//alpha (300) controlFolder = "Z:\Info\";
//alpha (300) optimizeBackupFolder = "Z:\Info\Backups\";
//alpha (300) logExcelFileSystem = "Z:\Program\Menus\Operator Statistics\Operator Statistics Analyzer.xlsm";
alpha (300) controlFilename = "\\CEN-SVR-02\Info\armeniaControl.dat";
alpha (300) namesFilename = "\\CEN-SVR-02\Info\armeniaNames.dat";
alpha (300) entryProgram = "\\\\CEN-SVR-02\\\Program\EnterData.ent";
alpha (300) keyerMenuProgram = "\\\\CEN-SVR-02\Program\Menus\Keyer Menu\keyerMenu.ent";
alpha (300) verifierMenuProgram = "\\\\CEN-SVR-02\Program\Menus\Verifier Menu\verifierMenu.ent";
alpha (300) optimizeProgram = "\\\\CEN-SVR-02\Program\Menus\Optimize Database\optimizeDatabase.bch";
alpha (300) controlFolder = "\\CEN-SVR-02\Info\";
alpha (300) optimizeBackupFolder = "\\CEN-SVR-02\Info\Backups\";
alpha (300) logExcelFileSystem = "\\CEN-SVR-02\Program\Menus\Operator Statistics\Operator Statistics Analyzer.xlsm";
alpha (300) localControlFilename = "C:\Census\armeniaControl.dat";
alpha (300) localCensusTempFilename = "C:\Census\";
alpha (300) localConcatenatedFilename = "C:\Census\Concatenated\ArmeniaCensus_%d.dat";
alpha (300) localConcatenatedLogsFilename = "C:\Census\Logs\ArmeniaCensusLogs_%d.csv";
alpha (300) logExcelFileLocal = "C:\Census\Logs\Operator Statistics Analyzer.xlsm";
alpha (300) excelPath = "C:\Program Files (x86)\Microsoft Office\Office14\EXCEL.exe"; // Office 2010
alpha (300) excelPath2 = "C:\Program Files\Microsoft Office\Office14\EXCEL.exe"; // Office 2010
alpha (300) operationStatisticsProgram = "\\\\CEN-SVR-02\Program\Menus\Operation Statistics\operationStatistics.xtb";
alpha (300) localOperationStatisticsFilename = "C:\Census\Logs\OperationStatistics_%d.tbw";
alpha (300) localNamesFilename;
alpha (300) tempFilename;
alpha (300) str;
alpha (2000) findFilesInfo;
alpha (300) viewDiscrepenciesProgram = "\\\\CEN-SVR-02\Program\Menus\Supervisor Menu\View Discrepencies\viewDiscrepencies.ent";

file pffFile,discrepenciesFile;


numeric operatorNumber;

numeric counter,selectionCode;

numeric assignMode,returnMode,KEYER = 1,VERIFIER = 2,APPROVAL = 3;

numeric saveChangesFromExternalForm;


function gotoMainMenu()
	move to SUPERVISORMENU_QUEST_FORM;
end;


function OnStop()
	gotoMainMenu();
end;

function OnKey(keystroke) // 20120201 allow a supervisor to fake another supervisor

	if keystroke in 7049:7057 then
		operatorNumber = keystroke - 7048;
		OPERATOR_NAME = maketext("spoofing: super%d",operatorNumber);
		gotoMainMenu();
		OnKey = 0;
	
	else
		OnKey = keystroke;
		
	endif;

end;


alpha (300) storage_datFilename,storage_logFilename,storage_lstFilename,storage_notFilename,storage_stsFilename;
alpha (300) entry_datFilename,entry_logFilename,entry_lstFilename,entry_notFilename,entry_stsFilename;
//alpha (100) storage_baseDataFilename = "Z:\Data\Complete";
alpha (100) storage_baseDataFilename = "\\CEN-SVR-02\Data\Complete\";
alpha (100) entry_baseDataFilename;
alpha (300) localBackupFilename;


function generateFilenamesOnServer(marz,region,hamaynk,bnakavajr,portfel,operator)

	storage_datFilename = maketext("%s%s\%03d%d%03d%d%03d.dat",strip(storage_baseDataFilename),"dat",marz,region,hamaynk,bnakavajr,portfel);
	storage_logFilename = maketext("%s%s\%03d%d%03d%d%03d.dat.log",strip(storage_baseDataFilename),"log",marz,region,hamaynk,bnakavajr,portfel);
	storage_lstFilename = maketext("%s%s\%03d%d%03d%d%03d.dat.lst",strip(storage_baseDataFilename),"lst",marz,region,hamaynk,bnakavajr,portfel);
	storage_notFilename = maketext("%s%s\%03d%d%03d%d%03d.dat.not",strip(storage_baseDataFilename),"not",marz,region,hamaynk,bnakavajr,portfel);
	storage_stsFilename = maketext("%s%s\%03d%d%03d%d%03d.dat.sts",strip(storage_baseDataFilename),"sts",marz,region,hamaynk,bnakavajr,portfel);
	
	//entry_baseDataFilename = maketext("Z:\Data\oper%d",operator);
	entry_baseDataFilename = maketext("\\CEN-SVR-02\Data\oper%d",operator);
	
	entry_datFilename = maketext("%s\%03d%d%03d%d%03d.dat",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
	entry_logFilename = maketext("%s\%03d%d%03d%d%03d.dat.log",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
	entry_lstFilename = maketext("%s\%03d%d%03d%d%03d.dat.lst",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
	entry_notFilename = maketext("%s\%03d%d%03d%d%03d.dat.not",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
	entry_stsFilename = maketext("%s\%03d%d%03d%d%03d.dat.sts",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);

	localBackupFilename = maketext("%sDataBackups\%03d%d%03d%d%03d_%d%06d.dat",strip(localCensusTempFilename),marz,region,hamaynk,bnakavajr,portfel,sysdate("YYYYMMDD"),systime());
	
end;


// similar to the above function
alpha (300) fromFilename,toFilename;

function alpha (300) calculateFilenameForMove(marz,region,hamaynk,bnakavajr,portfel,operator,fileType) // if operator = 0 it means the storage filename

	if operator = 0 then
		if fileType = 1 then		calculateFilenameForMove = maketext("%s%s\%03d%d%03d%d%03d.dat",strip(storage_baseDataFilename),"dat",marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 2 then	calculateFilenameForMove = maketext("%s%s\%03d%d%03d%d%03d.dat.log",strip(storage_baseDataFilename),"log",marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 3 then	calculateFilenameForMove = maketext("%s%s\%03d%d%03d%d%03d.dat.lst",strip(storage_baseDataFilename),"lst",marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 4 then	calculateFilenameForMove = maketext("%s%s\%03d%d%03d%d%03d.dat.not",strip(storage_baseDataFilename),"not",marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 5 then	calculateFilenameForMove = maketext("%s%s\%03d%d%03d%d%03d.dat.sts",strip(storage_baseDataFilename),"sts",marz,region,hamaynk,bnakavajr,portfel);
		endif;
	
	else
		entry_baseDataFilename = maketext("\\CEN-SVR-02\Data\oper%d",operator);
	
		if fileType = 1 then		calculateFilenameForMove = maketext("%s\%03d%d%03d%d%03d.dat",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 2 then	calculateFilenameForMove = maketext("%s\%03d%d%03d%d%03d.dat.log",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 3 then	calculateFilenameForMove = maketext("%s\%03d%d%03d%d%03d.dat.lst",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 4 then	calculateFilenameForMove = maketext("%s\%03d%d%03d%d%03d.dat.not",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
		elseif fileType = 5 then	calculateFilenameForMove = maketext("%s\%03d%d%03d%d%03d.dat.sts",strip(entry_baseDataFilename),marz,region,hamaynk,bnakavajr,portfel);
		endif;
	
	endif;

end;

numeric fileMoveSuccesses;

function moveFilesFromStorageToEntry()

	fileMoveSuccesses = 0;

	inc(fileMoveSuccesses,filerename(strip(storage_datFilename),strip(entry_datFilename)));
	inc(fileMoveSuccesses,filerename(strip(storage_logFilename),strip(entry_logFilename)));
	inc(fileMoveSuccesses,filerename(strip(storage_lstFilename),strip(entry_lstFilename)));
	inc(fileMoveSuccesses,filerename(strip(storage_notFilename),strip(entry_notFilename)));
	inc(fileMoveSuccesses,filerename(strip(storage_stsFilename),strip(entry_stsFilename)));

	filedelete(concat(strip(entry_datFilename),".idx")); // delete the index in the entry folder if it exists

	moveFilesFromStorageToEntry = fileMoveSuccesses;

end;


function moveFilesFromEntryToStorage()

	fileMoveSuccesses = 0;

	inc(fileMoveSuccesses,filerename(strip(entry_datFilename),strip(storage_datFilename)));
	inc(fileMoveSuccesses,filerename(strip(entry_logFilename),strip(storage_logFilename)));
	inc(fileMoveSuccesses,filerename(strip(entry_lstFilename),strip(storage_lstFilename)));
	inc(fileMoveSuccesses,filerename(strip(entry_notFilename),strip(storage_notFilename)));
	inc(fileMoveSuccesses,filerename(strip(entry_stsFilename),strip(storage_stsFilename)));
	
	filedelete(concat(strip(entry_datFilename),".idx")); // delete the index in the entry folder if it exists
	
	moveFilesFromEntryToStorage = fileMoveSuccesses;

end;


function moveFilesFromStorageToEntryNoErrors()

	if moveFilesFromStorageToEntry() = 5 then
		moveFilesFromStorageToEntryNoErrors = 1; // success
	
	else // move back the files that were potentially moved
		moveFilesFromStorageToEntryNoErrors = 0;
		moveFilesFromEntryToStorage();

	endif;

end;


function moveFilesFromEntryToStorageNoErrors()

	if moveFilesFromEntryToStorage() = 5 then
		moveFilesFromEntryToStorageNoErrors = 1; // success
	
	else // move back the files that were potentially moved
		moveFilesFromEntryToStorageNoErrors = 0;
		moveFilesFromStorageToEntry();

	endif;

end;


function resetAssignFormValues()

	ASSIGN_CODE = notappl; // reset all the values (in case this form has been filled out before)
	ASSIGN_MARZ_CODE = notappl;
	ASSIGN_REGION_CODE = notappl;
	ASSIGN_HAMAYNK_CODE = notappl;
	ASSIGN_BNAKAVAJR_CODE = notappl;
	ASSIGN_PORTFEL_CODE = notappl;
	ASSIGN_MARZ_NAME = "";
	ASSIGN_REGION_NAME = "";
	ASSIGN_HAMAYNK_NAME = "";
	ASSIGN_BNAKAVAJR_NAME = "";

end;


function resetOverrideFormValues()

	OVERRIDE_MARZ_CODE = notappl; // reset all the values (in case this form has been filled out before)
	OVERRIDE_REGION_CODE = notappl;
	OVERRIDE_HAMAYNK_CODE = notappl;
	OVERRIDE_BNAKAVAJR_CODE = notappl;
	OVERRIDE_PORTFEL_CODE = notappl;

end;


function resetReturnFormValues()

	RETURN_MARZ_CODE = notappl; // reset all the values (in case this form has been filled out before)
	RETURN_REGION_CODE = notappl;
	RETURN_HAMAYNK_CODE = notappl;
	RETURN_BNAKAVAJR_CODE = notappl;
	RETURN_PORTFEL_CODE = notappl;
	RETURN_MARZ_NAME = "";
	RETURN_REGION_NAME = "";
	RETURN_HAMAYNK_NAME = "";
	RETURN_BNAKAVAJR_NAME = "";
	RETURN_DISCREPENCIES = "";
	
	do counter = 1 while counter <= 3
		RETURN_QUESTIONNAIRES(counter) = notappl;
		RETURN_ENUMERATED_MALE(counter) = notappl;
		RETURN_ENUMERATED_FEMALE(counter) = notappl;
		RETURN_ENUMERATED_TOTAL(counter) = notappl;
		RETURN_TEMP_PRESENT_MALE(counter) = notappl;
		RETURN_TEMP_PRESENT_FEMALE(counter) = notappl;
		RETURN_TEMP_PRESENT_TOTAL(counter) = notappl;
		RETURN_ABSENT_MALE(counter) = notappl;
		RETURN_ABSENT_FEMALE(counter) = notappl;
		RETURN_ABSENT_TOTAL(counter) = notappl;
	enddo;

end;


function updateReturnType()

	if returnMode = KEYER then
		RETURN_TYPE = "Return from Keying";

	elseif returnMode = VERIFIER then
		RETURN_TYPE = "Return from Verifying";

	elseif returnMode = APPROVAL then
		RETURN_TYPE = "Approve Bag";
	
	endif;

end;

numeric assignFromVerifyFlag,assignFromWorkFlag,returnFromWorkFlag;

function moveToAssignFormFromVerify(modeType)
	assignMode = modeType;
	assignFromVerifyFlag = 1;
	move to ASSIGN_FORM;
end;

function moveToAssignFormFromWork(modeType,rowNumber)
	assignMode = modeType;
	assignFromWorkFlag = rowNumber;
	move to ASSIGN_FORM;
end;

function moveToReturnFormFromWork(modeType,rowNumber)
	returnMode = modeType;
	returnFromWorkFlag = rowNumber;
	move to RETURN_FORM;
end;


function resetFFFormValues(resetType)

	if resetType = 1 then // reset all
		FF_MARZ_CODE = notappl; // reset all the values (in case this form has been filled out before)
		FF_REGION_CODE = notappl;
		FF_HAMAYNK_CODE = notappl;
		FF_BNAKAVAJR_CODE = notappl;
		FF_PORTFEL_CODE = notappl;
		FF_MENU_SELECTION = notappl;
		FF_OPERATOR_CODE = notappl;
	endif;
	
	do counter = 1 while counter <= 5
		COMPLETE_FOLDER(counter) = ' ';
		KEYER_FOLDER(counter) = ' ';
		VERIFIER_FOLDER(counter) = ' ';
	enddo;

end;


function calculatePaths()

	// the !n will be replaced with \n
	findFilesInfo = "File paths:!n!n";
	
	generateFilenamesOnServer(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,KEYER_ID);
	
	numeric numFilesFound;	
	
	if fileexist(strip(storage_datFilename)) then	COMPLETE_FOLDER(1) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(storage_datFilename));	inc(numFilesFound);	endif;
	if fileexist(strip(storage_logFilename)) then	COMPLETE_FOLDER(2) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(storage_logFilename));	inc(numFilesFound);	endif;
	if fileexist(strip(storage_lstFilename)) then	COMPLETE_FOLDER(3) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(storage_lstFilename));	inc(numFilesFound);	endif;
	if fileexist(strip(storage_notFilename)) then	COMPLETE_FOLDER(4) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(storage_notFilename));	inc(numFilesFound);	endif;
	if fileexist(strip(storage_stsFilename)) then	COMPLETE_FOLDER(5) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(storage_stsFilename));	inc(numFilesFound);	endif;
	
	if KEYER_ID <> notappl then
		if fileexist(strip(entry_datFilename)) then	KEYER_FOLDER(1) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_datFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_logFilename)) then	KEYER_FOLDER(2) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_logFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_lstFilename)) then	KEYER_FOLDER(3) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_lstFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_notFilename)) then	KEYER_FOLDER(4) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_notFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_stsFilename)) then	KEYER_FOLDER(5) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_stsFilename));	inc(numFilesFound);	endif;
	endif;
	
	if VERIFIER_ID <> notappl then
		generateFilenamesOnServer(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,VERIFIER_ID);
		if fileexist(strip(entry_datFilename)) then	VERIFIER_FOLDER(1) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_datFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_logFilename)) then	VERIFIER_FOLDER(2) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_logFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_lstFilename)) then	VERIFIER_FOLDER(3) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_lstFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_notFilename)) then	VERIFIER_FOLDER(4) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_notFilename));	inc(numFilesFound);	endif;
		if fileexist(strip(entry_stsFilename)) then	VERIFIER_FOLDER(5) = 'X';	findFilesInfo = maketext("%s%s!n",strip(findFilesInfo),strip(entry_stsFilename));	inc(numFilesFound);	endif;
	endif;
	

	// replace all the \s with /s so as to not trigger the newline character (\n)
	do counter = length(strip(findFilesInfo)) while counter >= 1 by -1
		if findFilesInfo[counter:1] = '\' then
			findFilesInfo[counter:1] = '/';
		elseif findFilesInfo[counter:1] = '!' then
			findFilesInfo[counter:1] = '\';
		endif;	
	enddo;
	
	calculatePaths = numFilesFound;

end;


function resetViewWorkFormValues(resetType)

	if resetType = 1 then // reset all
		BAGS_ASSIGNED_KEYING = notappl;
		BAGS_KEYED_INCOMPLETE = notappl;
		BAGS_FINISHED_KEYING = notappl;
		BAGS_ASSIGNED_VERIFYING = notappl;
		BAGS_VERIFIED_INCOMPLETE = notappl;
		BAGS_AWAITING_APPROVAL = notappl;
		BAGS_APPROVED = notappl;
		VW_MENU_SELECTION = notappl;
		VIEW_FILTER = notappl;
	endif;
	
	do counter = 1 while counter <= maxocc(VW_BAGS000)
		VW_MARZ_CODE(counter) = notappl;
		VW_REGION_CODE(counter) = notappl;
		VW_HAMAYNK_CODE(counter) = notappl;
		VW_BNAKAVAJR_CODE(counter) = notappl;
		VW_PORTFEL_CODE(counter) = notappl;
		VW_OPERATOR(counter) = notappl;
		VW_BAG_STATUS(counter) = notappl;
	enddo;

end;


numeric numRowsInWorkGrid;

function populateWorkFormValues(statusType)

	locate(ARMENIACONTROL_DICT,>=""); // go to right before the first case in the file
	
	numRowsInWorkGrid = 0;
	
	numeric bak,bki,bfk,bav,bvi,baa,ba,recodedStatus;
	
	
	do while loadcase(ARMENIACONTROL_DICT) // load the next case in the file
	
		if SUPERVISOR_ID = operatorNumber and numRowsInWorkGrid < maxocc(VW_BAGS000) then
		
			if STATUS = 8 then
				inc(ba);
			
			else
				// the status codes on the screen are different from the ones in the file
				recode	STATUS	=>	recodedStatus;
						1			=>	1;
						4			=>	2;
						2-3			=>	3;
						5			=>	4;
						6			=>	5;
						7			=>	6;
				endrecode;
				
				if statusType and statusType <> recodedStatus then
					// do nothing with this entry
				
				else
					inc(numRowsInWorkGrid);
					
					VW_MARZ_CODE(numRowsInWorkGrid) = ID_MARZ;
					VW_REGION_CODE(numRowsInWorkGrid) = ID_REGION;
					VW_HAMAYNK_CODE(numRowsInWorkGrid) = ID_HAMAYNK;
					VW_BNAKAVAJR_CODE(numRowsInWorkGrid) = ID_BNAKAVAJR;
					VW_PORTFEL_CODE(numRowsInWorkGrid) = ID_PORTFEL;
					VW_BAG_STATUS(numRowsInWorkGrid) = recodedStatus;
				
					if recodedStatus = 1 then		inc(bak);	VW_OPERATOR(numRowsInWorkGrid) = KEYER_ID;
					elseif recodedStatus = 2 then	inc(bki);
					elseif recodedStatus = 3 then	inc(bfk);
					elseif recodedStatus = 4 then	inc(bav);	VW_OPERATOR(numRowsInWorkGrid) = VERIFIER_ID;
					elseif recodedStatus = 5 then	inc(bvi);
					elseif recodedStatus = 6 then	inc(baa);
					endif;
				
				endif;
			
			endif;
		
		endif;
		
	enddo;
	
	if statusType = 0 then // don't reset these values when applying a filter
		BAGS_ASSIGNED_KEYING = bak;
		BAGS_KEYED_INCOMPLETE = bki;
		BAGS_FINISHED_KEYING = bfk;
		BAGS_ASSIGNED_VERIFYING = bav;
		BAGS_VERIFIED_INCOMPLETE = bvi;
		BAGS_AWAITING_APPROVAL = baa;
		BAGS_APPROVED = ba;
	endif;

end;


function saveChangesToSharedDatabase()

	close(ARMENIACONTROL_DICT);
	
	do while not setfile(ARMENIACONTROL_DICT,strip(controlFilename))
		errmsg("Error connecting to the master database. Please try again in a few seconds.");
	enddo;
	
	writecase(ARMENIACONTROL_DICT); // make the change to the shared database
	
	close(ARMENIACONTROL_DICT); // close the shared database
	
	// now reload the local copy
	if not setfile(ARMENIACONTROL_DICT,strip(localControlFilename)) then
		errmsg("Control file could not be located on the local computer. Check network connection.");
		stop(1);
	endif;

end;

function doesKeyerHaveBag(keyerCode)

	doesKeyerHaveBag = 0; // assume no
	
	locate(ARMENIACONTROL_DICT,>=""); // go to right before the first case in the file

	do while loadcase(ARMENIACONTROL_DICT) // load the next case in the file
	
		if KEYER_ID = keyerCode and STATUS = 1 then
			doesKeyerHaveBag = 1;
			exit;
		endif;
	
	
	enddo;	

end;



PROC SUPERVISORMENU_FF

preproc

	setfont(notes,"Times LatArm",16); // so that the discrepency notes use Armenian font
	
	if not fileexist(excelPath) then
		excelPath = excelPath2;
	endif;
	

PROC SUPERVISORMENU_QUEST

preproc

	userbar(clear);
	userbar(add button,"Main Menu",gotoMainMenu);
	userbar(show);

	OPERATOR_NAME = getusername();
	
	if OPERATOR_NAME = "Ruzanna" then
		OPERATOR_NAME = "super7";

	elseif pos("super",tolower(OPERATOR_NAME)) <> 1 then
		errmsg("You must be logged in as a supervisor on this machine to access this program.");
		stop(1);
	endif;

	operatorNumber = tonumber(OPERATOR_NAME[6]); // starting at position 6 will skip past "super"

	// copy the names list to the local machine so that it can be opened (due to file sharing problems in CSPro)
	localNamesFilename = concat(pathname(temp),"armeniaNames.dat");

	// delete the file if it already exists so that we can get a new one
	filedelete(strip(localNamesFilename));
	filedelete(concat(strip(localNamesFilename),".idx")); // delete the index file as well

	if not filecopy(strip(namesFilename),strip(localNamesFilename)) then
		errmsg("Names file could not be located on server. Check network connection.");
		stop(1);
	endif;

	if not setfile(ARMENIANAMES_DICT,strip(localNamesFilename)) then // open the names file
		errmsg("Names file could not be located on the local computer. Check network connection.");
		stop(1);
	endif;
	
	
	// get the latest copy of the control database from the server

	// delete the file if it already exists so that we can get a new one
	filedelete(strip(localControlFilename));
	filedelete(concat(strip(localControlFilename),".idx")); // delete the index file as well

	if not filecopy(strip(controlFilename),strip(localControlFilename)) then
		errmsg("Control file could not be located on server. Check network connection.");
		stop(1);
	endif;	

	if not setfile(ARMENIACONTROL_DICT,strip(localControlFilename)) then // open the control file
		errmsg("Control file could not be located on the local computer. Check network connection.");
		stop(1);
	endif;


PROC MENU_SELECTION

	numeric selection = MENU_SELECTION;

	MENU_SELECTION = notappl; // make the menu selection blank (so as to not have it show up the next time)

	if selection = 1 then // assign to keyer
		assignMode = KEYER;
		move to ASSIGN_FORM;
	

	elseif selection = 2 then // return from keyer
		returnMode = KEYER;
		move to RETURN_FORM;


	elseif selection = 3 then // assign to verifier
		assignMode = VERIFIER;
		move to ASSIGN_FORM;


	elseif selection = 4 then // return from verifier
		returnMode = VERIFIER;
		move to RETURN_FORM;


	elseif selection = 5 then // approve bag
		returnMode = APPROVAL;
		move to RETURN_FORM;


	elseif selection = 6 then // view my work
		move to VIEW_WORK_FORM;


	elseif selection = 7 then // log in as a keyer or verifier
		move to FAKE_USER_FORM;
	

	elseif selection = 8 then // make advanced changes to the database
		move to OVERRIDE_FORM;


	elseif selection = 9 then // optimize database
		
		// the name of the database backup
		tempFilename = maketext("%s%d%06d.dat",strip(optimizeBackupFolder),sysdate("YYYYMMDD"),systime());
		
		if not filerename(strip(controlFilename),strip(tempFilename)) then
			errmsg("Error moving the control database. It may currently be in use.");
			reenter;
		endif;

		// create the pff in the temporary folder
		setfile(pffFile,maketext("%s%d%06d.pff",pathname(temp),sysdate("YYYYMMDD"),systime()));
		
		filewrite(pffFile,"[Run Information]");
		filewrite(pffFile,"Version=CSPro 4.1");
		filewrite(pffFile,"AppType=Batch");
		filewrite(pffFile,"[Files]");
		filewrite(pffFile,"Application=%s",strip(optimizeProgram));
		//filewrite(pffFile,"InputData=%s",strip(tempFilename));
		//filewrite(pffFile,"OutputData=%s",strip(controlFilename));
		filewrite(pffFile,"InputData=\%s",strip(tempFilename));
		filewrite(pffFile,"OutputData=\%s",strip(controlFilename));
		filewrite(pffFile,"Listing=%soptimizeDatabase.lst",strip(localCensusTempFilename));
		filewrite(pffFile,"[Parameters]");
		filewrite(pffFile,"ViewListing=Never");
		filewrite(pffFile,"ViewResults=No");
	
		close(pffFile);
		
		execpff(filename(pffFile),wait);
	
		// delete the old index
		filedelete(concat(strip(controlFilename),".idx"));
		
		errmsg("Database optimized successfully.");
		reenter;
		

	elseif selection = 10 then // find files
		move to FIND_FILES_FORM;
		

	elseif selection = 11 then // concatenate data files
	
		if operatorNumber <> 7 then
			errmsg("You do not have access to this feature.");
			reenter;
		endif;

		tempFilename = maketext(strip(localConcatenatedFilename),sysdate("YYYYMMDD"));
	
		// create the pff in the temporary folder
		setfile(pffFile,maketext("%s%d%06d.pff",pathname(temp),sysdate("YYYYMMDD"),systime()));
		
		filewrite(pffFile,"[Run Information]");
		filewrite(pffFile,"Version=CSPro 4.1");
		filewrite(pffFile,"AppType=Concatenate");
		filewrite(pffFile,"[Files]");
		//filewrite(pffFile,"InputData=%sdat\*.dat",strip(storage_baseDataFilename));
		filewrite(pffFile,"InputData=\%sdat\*.dat",strip(storage_baseDataFilename));
		filewrite(pffFile,"OutputData=%s",strip(tempFilename));
		filewrite(pffFile,"Listing=%sCSConcat.lst",pathname(temp));
		filewrite(pffFile,"[Parameters]");
		filewrite(pffFile,"ViewListing=Never");
		filewrite(pffFile,"ViewResults=No");
	
		close(pffFile);
		
		execpff(filename(pffFile),wait);
		
		if fileexist(strip(tempFilename)) then
			errmsg("Files concatenated and placed here: %s",strip(tempFilename));
		
		else
			errmsg("There was an error concatenating the data files.");
		
		endif;
		
		reenter;
	

	elseif selection = 12 then // concatenate logs and run Excel statistics program
	
		if operatorNumber <> 7 then
			errmsg("You do not have access to this feature.");
			reenter;
		endif;
	
		tempFilename = maketext(strip(localConcatenatedLogsFilename),sysdate("YYYYMMDD"));
	
		// create the pff in the temporary folder
		setfile(pffFile,maketext("%s%d%06d.pff",pathname(temp),sysdate("YYYYMMDD"),systime()));
		
		filewrite(pffFile,"[Run Information]");
		filewrite(pffFile,"Version=CSPro 4.1");
		filewrite(pffFile,"AppType=Concatenate");
		filewrite(pffFile,"[Files]");
		//filewrite(pffFile,"InputData=%slog\*.log",strip(storage_baseDataFilename));
		filewrite(pffFile,"InputData=\%slog\*.log",strip(storage_baseDataFilename));
		filewrite(pffFile,"OutputData=%s",strip(tempFilename));
		filewrite(pffFile,"Listing=%sCSConcat.lst",pathname(temp));
		filewrite(pffFile,"[Parameters]");
		filewrite(pffFile,"ViewListing=Never");
		filewrite(pffFile,"ViewResults=No");
	
		close(pffFile);
		
		execpff(filename(pffFile),wait);
		
		if not fileexist(strip(tempFilename)) then
			errmsg("There was an error concatenating the logs.");
			reenter;
		endif;
		
		// copy the statistics program
		filecopy(strip(logExcelFileSystem),strip(logExcelFileLocal));

		execsystem(maketext('%s "%s"',excelPath,strip(tempFilename)));
		execsystem(maketext('%s "%s"',excelPath,strip(logExcelFileLocal)));
		

		// create the table with operation statistics
		tempFilename = maketext(strip(localOperationStatisticsFilename),sysdate("YYYYMMDD"));
	
		// create the pff in the temporary folder
		setfile(pffFile,maketext("%s%d%06d.pff",pathname(temp),sysdate("YYYYMMDD"),systime()));
		
		filewrite(pffFile,"[Run Information]");
		filewrite(pffFile,"Version=CSPro 4.1");
		filewrite(pffFile,"AppType=Tabulation");
		filewrite(pffFile,"Operation=All");
		filewrite(pffFile,"[Files]");
		filewrite(pffFile,"Application=%s",strip(operationStatisticsProgram));
		filewrite(pffFile,"InputData=\%s",strip(controlFilename));
		filewrite(pffFile,"Listing=%sCSTab.lst",pathname(temp));
		filewrite(pffFile,"OutputTBW=%s",strip(tempFilename));
		filewrite(pffFile,"[Parameters]");
		filewrite(pffFile,"ViewListing=Never");
		filewrite(pffFile,"ViewResults=Yes");
	
		close(pffFile);
		
		execpff(filename(pffFile),wait);
		
		reenter;


	elseif selection = 99 then // quit
		stop(1);


	else
		errmsg("Invalid selection. Please reenter.");
		reenter;

	endif;


PROC FAKE_USER_FORM

preproc

	// reset all the values (in case this form has been filled out before)
	FAKE_OPERATOR_NUMBER = notappl;
	FAKE_MODE = notappl;


PROC FAKE_MODE

	if not FAKE_MODE in 1:2 then
		errmsg("Enter a valid operator number or entry mode.");
		reenter;
	endif;
	
	// create the pff in the temporary folder
	setfile(pffFile,maketext("%s%d%06d.pff",pathname(temp),sysdate("YYYYMMDD"),systime()));
	
	filewrite(pffFile,"[Run Information]");
	filewrite(pffFile,"Version=CSPro 4.1");
	filewrite(pffFile,"AppType=Entry");
	
	filewrite(pffFile,"[DataEntryInit]");
	filewrite(pffFile,"OperatorID=oper%d",FAKE_OPERATOR_NUMBER);
	filewrite(pffFile,"Lock=Modify,Verify,Stats");
	filewrite(pffFile,"FullScreen=Yes");
	filewrite(pffFile,"NoFileOpen=Yes");
	filewrite(pffFile,"Interactive=Off");

	filewrite(pffFile,"[Files]");
	
	if FAKE_MODE = 1 then
		filewrite(pffFile,"Application=%s",strip(keyerMenuProgram));
	
	else
		filewrite(pffFile,"Application=%s",strip(verifierMenuProgram));
	
	endif;
	
	filewrite(pffFile,"[ExternalFiles]");
	filewrite(pffFile,"ARMENIANAMES_DICT=%sjunk1.txt",strip(localCensusTempFilename));
	filewrite(pffFile,"ARMENIACONTROL_DICT=%sjunk2.txt",strip(localCensusTempFilename));
	filewrite(pffFile,"[UserFiles]");
	filewrite(pffFile,"INPUTFILE=");

	close(pffFile);
	
	execpff(filename(pffFile));

	stop(1);
	
	
PROC ASSIGN_MARZ_CODE

onfocus

	resetAssignFormValues();
	
	if assignMode = KEYER then
		ASSIGN_TYPE = "for keying";

	elseif assignMode = VERIFIER then
		ASSIGN_TYPE = "for verifying";
	
	endif;
	
	if assignFromVerifyFlag then
		ASSIGN_MARZ_CODE = visualvalue(RETURN_MARZ_CODE);
		ASSIGN_REGION_CODE = visualvalue(RETURN_REGION_CODE);
		ASSIGN_HAMAYNK_CODE = visualvalue(RETURN_HAMAYNK_CODE);
		ASSIGN_BNAKAVAJR_CODE = visualvalue(RETURN_BNAKAVAJR_CODE);
		ASSIGN_PORTFEL_CODE = visualvalue(RETURN_PORTFEL_CODE);
	
		assignFromVerifyFlag = 0;
		advance to ASSIGN_CODE;
	
	elseif assignFromWorkFlag then

		ASSIGN_MARZ_CODE = visualvalue(VW_MARZ_CODE(assignFromWorkFlag));
		ASSIGN_REGION_CODE = visualvalue(VW_REGION_CODE(assignFromWorkFlag));
		ASSIGN_HAMAYNK_CODE = visualvalue(VW_HAMAYNK_CODE(assignFromWorkFlag));
		ASSIGN_BNAKAVAJR_CODE = visualvalue(VW_BNAKAVAJR_CODE(assignFromWorkFlag));
		ASSIGN_PORTFEL_CODE = visualvalue(VW_PORTFEL_CODE(assignFromWorkFlag));

		assignFromWorkFlag = 0;
		advance to ASSIGN_CODE;
	
	endif;

postproc

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d",ASSIGN_MARZ_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = ASSIGN_MARZ_CODE then

		ASSIGN_MARZ_NAME = N_MARZ_NAME;

	else
		ASSIGN_MARZ_NAME = "<invalid>";

	endif;


PROC ASSIGN_REGION_CODE

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d%d",ASSIGN_MARZ_CODE,ASSIGN_REGION_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = ASSIGN_MARZ_CODE and N_REGION = ASSIGN_REGION_CODE then

		ASSIGN_REGION_NAME = N_REGION_NAME;

	else
		ASSIGN_REGION_NAME = "<invalid>";

	endif;


PROC ASSIGN_HAMAYNK_CODE

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d%d%03d",ASSIGN_MARZ_CODE,ASSIGN_REGION_CODE,ASSIGN_HAMAYNK_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = ASSIGN_MARZ_CODE and N_REGION = ASSIGN_REGION_CODE and
		N_HAMAYNK = ASSIGN_HAMAYNK_CODE then

		ASSIGN_HAMAYNK_NAME = N_HAMAYNK_NAME;

	else
		ASSIGN_HAMAYNK_NAME = "<invalid>";

	endif;


PROC ASSIGN_BNAKAVAJR_CODE

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d%d%03d%d",ASSIGN_MARZ_CODE,ASSIGN_REGION_CODE,ASSIGN_HAMAYNK_CODE,ASSIGN_BNAKAVAJR_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = ASSIGN_MARZ_CODE and N_REGION = ASSIGN_REGION_CODE and
		N_HAMAYNK = ASSIGN_HAMAYNK_CODE and N_BNAKAVAJR = ASSIGN_BNAKAVAJR_CODE then

		ASSIGN_BNAKAVAJR_NAME = N_BNAKAVAJR_NAME;

	else
		ASSIGN_BNAKAVAJR_NAME = "<invalid>";

	endif;


PROC ASSIGN_PORTFEL_CODE

	if not loadcase(ARMENIACONTROL_DICT,ASSIGN_MARZ_CODE,ASSIGN_REGION_CODE,ASSIGN_HAMAYNK_CODE,ASSIGN_BNAKAVAJR_CODE,ASSIGN_PORTFEL_CODE) then
		errmsg("Invalid geocode selected. Please reenter or check the master database.");
		reenter;
	endif;
	
	if assignMode = KEYER then
	
		if STATUS = 1 then
			errmsg("Bag has already been assigned to a keyer. Please enter another bag.");
			reenter;
	
		elseif STATUS in 2:3 then
			errmsg("Bag was already returned complete by oper%d. Would you still like to assign the bag?",KEYER_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
	
		elseif STATUS = 4 then
			errmsg("Bag was returned incomplete by oper%d. Would you still like to assign the bag?",KEYER_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
	
		elseif STATUS = 5 then
			errmsg("Bag has already been assigned to a verifier. Please enter another bag.");
			reenter;
	
		elseif STATUS in 6:7 then
			errmsg("Bag has returned from verification by oper%d. Would you still like to assign the bag for initial keying?",VERIFIER_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
	
		elseif STATUS = 8 then
			errmsg("Bag has already been approved by super%d. Would you still like to assign the bag for initial keying?",SUPERVISOR_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
	
		endif;


	elseif assignMode = VERIFIER then
	
		if STATUS = 1 then
			errmsg("Bag has already been assigned to a keyer. Please enter another bag.");
			reenter;
		
		elseif STATUS in 2:3 then
			// okay
	
		elseif STATUS = 4 then
			errmsg("Bag was returned incomplete by oper%d. Would you still like to assign the bag for verification?",KEYER_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
	
		elseif STATUS = 5 then
			errmsg("Bag has already been assigned to a verifier. Please enter another bag.");
			reenter;
	
		elseif STATUS in 6:7 then
			errmsg("Bag has returned from verification by oper%d. Would you still like to assign the bag for verification?",VERIFIER_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
	
		elseif STATUS = 8 then
			errmsg("Bag has already been approved by super%d. Would you still like to assign the bag for verification?",SUPERVISOR_ID) select("Yes",continue,"No",ASSIGN_PORTFEL_CODE);
		
		else
			errmsg("This bag has not been assigned for keying so it can not be verified.");
			reenter;
	
		endif;
	
	endif;
	

PROC ASSIGN_CODE

	// if necessary, move files to the folder of the operator
	generateFilenamesOnServer(ASSIGN_MARZ_CODE,ASSIGN_REGION_CODE,ASSIGN_HAMAYNK_CODE,ASSIGN_BNAKAVAJR_CODE,ASSIGN_PORTFEL_CODE,ASSIGN_CODE);

	if assignMode = KEYER then
	
		// 20120201: we want to make sure that nothing is already assigned to the operator
		if doesKeyerHaveBag(ASSIGN_CODE) then
			errmsg("A keyer can only have one bag at a time. Keyer has: %d %d %d %d %d",ID_MARZ,ID_REGION,ID_HAMAYNK,ID_BNAKAVAJR,ID_PORTFEL);
			reenter;
		
		else // go back to the bag that is to be checked out
			if not loadcase(ARMENIACONTROL_DICT,ASSIGN_MARZ_CODE,ASSIGN_REGION_CODE,ASSIGN_HAMAYNK_CODE,ASSIGN_BNAKAVAJR_CODE,ASSIGN_PORTFEL_CODE) then
				errmsg("This should never happen! Internal error!");
				reenter;
			endif;
		endif;
		
		
		if not moveFilesFromStorageToEntryNoErrors() and STATUS >= 2 then
			errmsg("There was an error moving files to the keyer's folder. Is the keyer code valid?");
			reenter;
		endif;
	
		KEYER_ID = ASSIGN_CODE;
		TO_KEYER_DATE = sysdate("YYYYMMDD");
		STATUS = 1;
		
		errmsg("Bag assigned to oper%d for keying.",KEYER_ID);
	

	elseif assignMode = VERIFIER then
	
		if KEYER_ID = ASSIGN_CODE then
			errmsg("Cannot assign a bag for verification to the same person who keyed the bag.");
			reenter;
	
		elseif not moveFilesFromStorageToEntryNoErrors() then
			errmsg("There was an error moving files to the verifier's folder. Is the verifier code valid?");
			reenter;
		endif;

		VERIFIER_ID = ASSIGN_CODE;
		TO_VERIFIER_DATE = sysdate("YYYYMMDD");
		STATUS = 5;
		
		errmsg("Bag assigned to oper%d for verification.",VERIFIER_ID);
		
	endif;
	
	SUPERVISOR_ID = operatorNumber;
	
	writecase(ARMENIACONTROL_DICT);
	saveChangesToSharedDatabase();
	
	resetAssignFormValues();
	move to ASSIGN_FORM;


PROC OVERRIDE_FORM

preproc

	resetOverrideFormValues();
	
	
PROC OVERRIDE_PORTFEL_CODE

	if not loadcase(ARMENIACONTROL_DICT,OVERRIDE_MARZ_CODE,OVERRIDE_REGION_CODE,OVERRIDE_HAMAYNK_CODE,OVERRIDE_BNAKAVAJR_CODE,OVERRIDE_PORTFEL_CODE) then
		errmsg("Invalid geocode selected. Please reenter or check the master database.");
		reenter;
	endif;
	
	userbar(hide);
	
	enter ARMENIACONTROL_FF;

	userbar(show);
	
	if saveChangesFromExternalForm = 1 then // save the changes
		writecase(ARMENIACONTROL_DICT);
		saveChangesToSharedDatabase();
	endif;
	
	resetOverrideFormValues();
	
	move to OVERRIDE_FORM;


PROC RETURN_MARZ_CODE

onfocus

	resetReturnFormValues();
	updateReturnType();

	if returnFromWorkFlag then

		RETURN_MARZ_CODE = visualvalue(VW_MARZ_CODE(returnFromWorkFlag));
		RETURN_REGION_CODE = visualvalue(VW_REGION_CODE(returnFromWorkFlag));
		RETURN_HAMAYNK_CODE = visualvalue(VW_HAMAYNK_CODE(returnFromWorkFlag));
		RETURN_BNAKAVAJR_CODE = visualvalue(VW_BNAKAVAJR_CODE(returnFromWorkFlag));
		RETURN_PORTFEL_CODE = visualvalue(VW_PORTFEL_CODE(returnFromWorkFlag));

		returnFromWorkFlag = 0;
		advance to RETURN_PORTFEL_CODE;
	
	endif;

postproc

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d",RETURN_MARZ_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = RETURN_MARZ_CODE then

		RETURN_MARZ_NAME = N_MARZ_NAME;

	else
		RETURN_MARZ_NAME = "<invalid>";

	endif;



PROC RETURN_REGION_CODE

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d%d",RETURN_MARZ_CODE,RETURN_REGION_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = RETURN_MARZ_CODE and N_REGION = RETURN_REGION_CODE then

		RETURN_REGION_NAME = N_REGION_NAME;

	else
		RETURN_REGION_NAME = "<invalid>";

	endif;


PROC RETURN_HAMAYNK_CODE

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d%d%03d",RETURN_MARZ_CODE,RETURN_REGION_CODE,RETURN_HAMAYNK_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = RETURN_MARZ_CODE and N_REGION = RETURN_REGION_CODE and
		N_HAMAYNK = RETURN_HAMAYNK_CODE then

		RETURN_HAMAYNK_NAME = N_HAMAYNK_NAME;

	else
		RETURN_HAMAYNK_NAME = "<invalid>";

	endif;


PROC RETURN_BNAKAVAJR_CODE

	if locate(ARMENIANAMES_DICT,>=,maketext("%03d%d%03d%d",RETURN_MARZ_CODE,RETURN_REGION_CODE,RETURN_HAMAYNK_CODE,RETURN_BNAKAVAJR_CODE)) and
		retrieve(ARMENIANAMES_DICT) and N_MARZ = RETURN_MARZ_CODE and N_REGION = RETURN_REGION_CODE and
		N_HAMAYNK = RETURN_HAMAYNK_CODE and N_BNAKAVAJR = RETURN_BNAKAVAJR_CODE then

		RETURN_BNAKAVAJR_NAME = N_BNAKAVAJR_NAME;

	else
		RETURN_BNAKAVAJR_NAME = "<invalid>";

	endif;


PROC RETURN_PORTFEL_CODE

	if not loadcase(ARMENIACONTROL_DICT,RETURN_MARZ_CODE,RETURN_REGION_CODE,RETURN_HAMAYNK_CODE,RETURN_BNAKAVAJR_CODE,RETURN_PORTFEL_CODE) then
		errmsg("Invalid geocode selected. Please reenter or check the master database.");
		reenter;
	endif;
	
	RETURN_DISCREPENCIES = DISCREPENCY_NOTES;
	
	if returnMode = KEYER then
	
		if STATUS = 1 then
			// okay
		
		elseif STATUS in 2:3,6:7 then
			errmsg("The bag was not given out for either keying or verifying. Switch to approval mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			returnMode = APPROVAL;
		
		elseif STATUS = 4 then
			errmsg("The keying of the bag is not complete. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);

		elseif STATUS = 5 then
			errmsg("The bag was given out for verifying. Switch to verification mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			returnMode = VERIFIER;

		elseif STATUS = 8 then
			errmsg("The bag has already been approved. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);

		else
			errmsg("The keying of the bag has not been started. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);
		
		endif;
	
		
	elseif returnMode = VERIFIER then

		if STATUS = 1 then
			errmsg("The bag was given out for keying. Switch to keying mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			returnMode = KEYER;
		
		elseif STATUS in 2:3,6:7 then
			errmsg("The bag was not given out for either keying or verifying. Switch to approval mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			returnMode = APPROVAL;
		
		elseif STATUS = 4 then
			errmsg("The keying of the bag is not complete. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);

		elseif STATUS = 5 then
			// okay

		elseif STATUS = 8 then
			errmsg("The bag has already been approved. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);

		else
			errmsg("The keying of the bag has not been started. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);
		
		endif;


	elseif returnMode = APPROVAL then

		if STATUS = 1 then
			errmsg("The bag was given out for keying. Switch to keying mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			returnMode = KEYER;
		
		elseif STATUS in 2:3,6:7 then
			// okay
		
		elseif STATUS = 4 then
			errmsg("The keying of the bag is not complete. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);

		elseif STATUS = 5 then
			errmsg("The bag was given out for verifying. Switch to verification mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			returnMode = VERIFIER;

		elseif STATUS = 8 then
			errmsg("The bag has already been approved. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);

		else
			errmsg("The keying of the bag has not been started. Switch to assignment mode?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
			moveToAssignFormFromVerify(KEYER);
		
		endif;

	endif;
	
	updateReturnType();
	
	if returnMode = KEYER then
		generateFilenamesOnServer(RETURN_MARZ_CODE,RETURN_REGION_CODE,RETURN_HAMAYNK_CODE,RETURN_BNAKAVAJR_CODE,RETURN_PORTFEL_CODE,KEYER_ID);
		
		// make sure that some files exist (there could be a situation where an assignment is checked back in before anything was keyed)
		if STATUS = 1 then

			if not fileexist(strip(entry_datFilename)) and not fileexist(strip(entry_logFilename)) and not 
					fileexist(strip(entry_lstFilename)) and not fileexist(strip(entry_notFilename)) and not fileexist(strip(entry_stsFilename)) then

				errmsg("The operator has not keyed any data for this bag. Check in and set status to untouched?") select("Yes",continue,"No",RETURN_PORTFEL_CODE);
				
				TO_KEYER_DATE = notappl;
				KEYER_ID = notappl;
				SUPERVISOR_ID = notappl;				
				STATUS = 0;
				
				writecase(ARMENIACONTROL_DICT);
				saveChangesToSharedDatabase();
				
				resetReturnFormValues();				
				move to RETURN_FORM;

			endif;
			
		endif;
	
	else // verifier and approval (in the case of approval we don't use the entry names)
		generateFilenamesOnServer(RETURN_MARZ_CODE,RETURN_REGION_CODE,RETURN_HAMAYNK_CODE,RETURN_BNAKAVAJR_CODE,RETURN_PORTFEL_CODE,VERIFIER_ID);
	
	endif;
	
	if returnMode in KEYER,VERIFIER then
		do while not moveFilesFromEntryToStorageNoErrors()
			errmsg("There was an error moving files from the entry directory to the storage directory. Perhaps the operator has not closed CSEntry.") select("Try Again",continue,"Cancel",RETURN_PORTFEL_CODE);
		enddo;
	endif;
	
	// if we are here, the data file should be in the server, we will move the main file to the supervisor's computer as a backup
	if not filecopy(strip(storage_datFilename),strip(localBackupFilename)) then
		errmsg("There was an error moving files from the storage directory to your computer.");
		reenter;
	endif;
	
	
	// these are the quick count values
	RETURN_QUESTIONNAIRES(1) = QUESTIONNAIRES;
	RETURN_ENUMERATED_MALE(1) = ENUMERATED_MALE;
	RETURN_ENUMERATED_FEMALE(1) = ENUMERATED_FEMALE;
	RETURN_ENUMERATED_TOTAL(1) = ENUMERATED_TOTAL;
	RETURN_TEMP_PRESENT_MALE(1) = TEMP_PRESENT_MALE;
	RETURN_TEMP_PRESENT_FEMALE(1) = TEMP_PRESENT_FEMALE;
	RETURN_TEMP_PRESENT_TOTAL(1) = TEMP_PRESENT_TOTAL;
	RETURN_ABSENT_MALE(1) = ABSENT_MALE;
	RETURN_ABSENT_FEMALE(1) = ABSENT_FEMALE;
	RETURN_ABSENT_TOTAL(1) = ABSENT_TOTAL;
	
	// 20120209 discrepency notes left from previous bags were getting assigned to bags without problems
	// due to the code below marked 20120209 reference
	putnote(strip(DISCREPENCY_NOTES));
	
	
	// load the data file
	numeric rq,rem,ref,ret,rtpm,rtpf,rtpt,ram,raf,rat;
	
	numeric thereAreDiscrepencies,expectedNumberOfForms;
	
	if setfile(ARMCEN2011_DICT,strip(localBackupFilename)) then
	
		setfile(discrepenciesFile,maketext("%sdiscrepencies%d%06d.dat",strip(localCensusTempFilename),sysdate("YYYYMMDD"),systime()),create);

		locate(ARMCEN2011_DICT,>=""); // go to right before the first case in the file
		
		do while loadcase(ARMCEN2011_DICT) // load the next case in the file
			inc(rq);
			
			// if either P02_POPC or P08_SEX are not valid values, these counts won't be precise (because of the else statements)
			for counter in ARMCEN2011_DICT.PERSON_REC
				// if 		P02_POPC(counter) = 1 then		inc(ret);	if P08_SEX(counter) = 1 then inc(rem);	else inc(ref);	endif;
				// elseif	P02_POPC(counter) = 2 then		inc(rtpt);	if P08_SEX(counter) = 1 then inc(rtpm);	else inc(rtpf);	endif;
				// else									inc(rat);	if P08_SEX(counter) = 1 then inc(ram);	else inc(raf);	endif;
				// endif;
				
				// 20120201 switch order so that else doesn't get lumped in with absent
				if 		P02_POPC(counter) = 3 then		inc(rat);	if P08_SEX(counter) = 1 then inc(ram);	else inc(raf);	endif;
				elseif	P02_POPC(counter) = 2 then		inc(rtpt);	if P08_SEX(counter) = 1 then inc(rtpm);	else inc(rtpf);	endif;
				else									inc(ret);	if P08_SEX(counter) = 1 then inc(rem);	else inc(ref);	endif;
				endif;
			endfor;
			
			filewrite(discrepenciesFile,"%s%02d%02d%02d",
				itemlist(Q_MARZ,Q_REGION,Q_HAMAYNK,Q_BNAKAVAJR,Q_PORTFEL,Q_HUNUM,Q_HHNUM,count(P02_POPC)),
				count(P02_POPC = 1),count(P02_POPC = 2),count(P02_POPC = 3));
			
			// calculate a measure for how many questionnaires (not households) are expected in the bag
			do while counter > 0
				inc(expectedNumberOfForms);
				inc(counter,-7);
			enddo;
		
		enddo;

		close(ARMCEN2011_DICT);

		// values from the data file
		RETURN_QUESTIONNAIRES(2) = rq;
		RETURN_ENUMERATED_MALE(2) = rem + rtpm + ram; // 20120201
		RETURN_ENUMERATED_FEMALE(2) = ref + rtpf + raf;
		RETURN_ENUMERATED_TOTAL(2) = ret + rtpt + rat;
		RETURN_TEMP_PRESENT_MALE(2) = rtpm;
		RETURN_TEMP_PRESENT_FEMALE(2) = rtpf;
		RETURN_TEMP_PRESENT_TOTAL(2) = rtpt;
		RETURN_ABSENT_MALE(2) = ram;
		RETURN_ABSENT_FEMALE(2) = raf;
		RETURN_ABSENT_TOTAL(2) = rat;
		
		// calculate the differences
		RETURN_QUESTIONNAIRES(3) = visualvalue(RETURN_QUESTIONNAIRES(1)) - visualvalue(RETURN_QUESTIONNAIRES(2));
		RETURN_ENUMERATED_MALE(3) = visualvalue(RETURN_ENUMERATED_MALE(1)) - visualvalue(RETURN_ENUMERATED_MALE(2));
		RETURN_ENUMERATED_FEMALE(3) = visualvalue(RETURN_ENUMERATED_FEMALE(1)) - visualvalue(RETURN_ENUMERATED_FEMALE(2));
		RETURN_ENUMERATED_TOTAL(3) = visualvalue(RETURN_ENUMERATED_TOTAL(1)) - visualvalue(RETURN_ENUMERATED_TOTAL(2));
		RETURN_TEMP_PRESENT_MALE(3) = visualvalue(RETURN_TEMP_PRESENT_MALE(1)) - visualvalue(RETURN_TEMP_PRESENT_MALE(2));
		RETURN_TEMP_PRESENT_FEMALE(3) = visualvalue(RETURN_TEMP_PRESENT_FEMALE(1)) - visualvalue(RETURN_TEMP_PRESENT_FEMALE(2));
		RETURN_TEMP_PRESENT_TOTAL(3) = visualvalue(RETURN_TEMP_PRESENT_TOTAL(1)) - visualvalue(RETURN_TEMP_PRESENT_TOTAL(2));
		RETURN_ABSENT_MALE(3) = visualvalue(RETURN_ABSENT_MALE(1)) - visualvalue(RETURN_ABSENT_MALE(2));
		RETURN_ABSENT_FEMALE(3) = visualvalue(RETURN_ABSENT_FEMALE(1)) - visualvalue(RETURN_ABSENT_FEMALE(2));
		RETURN_ABSENT_TOTAL(3) = visualvalue(RETURN_ABSENT_TOTAL(1)) - visualvalue(RETURN_ABSENT_TOTAL(2));
		
		close(discrepenciesFile);

		thereAreDiscrepencies = ( visualvalue(RETURN_QUESTIONNAIRES(1)) > expectedNumberOfForms ) or
								( not visualvalue(RETURN_ENUMERATED_TOTAL(3)) in -10:10 );

		if thereAreDiscrepencies then
		
			// 20120201 launch data entry showing the discrepencies
			setfile(pffFile,maketext("%s%d%06d.pff",pathname(temp),sysdate("YYYYMMDD"),systime()));
			
			filewrite(pffFile,"[Run Information]");
			filewrite(pffFile,"Version=CSPro 4.1");
			filewrite(pffFile,"AppType=Entry");
			filewrite(pffFile,"[DataEntryInit]");
			filewrite(pffFile,"StartMode=modify;%s",itemlist(Q_MARZ,Q_REGION,Q_HAMAYNK,Q_BNAKAVAJR,Q_PORTFEL));
			filewrite(pffFile,"LOCK=ADD,VERIFY,STATS");
			filewrite(pffFile,"NoFileOpen=YES");
			filewrite(pffFile,"Interactive=Off");
			filewrite(pffFile,"FullScreen=Yes");
			filewrite(pffFile,"[Files]");
			filewrite(pffFile,"Application=%s",strip(viewDiscrepenciesProgram));
			filewrite(pffFile,"InputData=%s",filename(discrepenciesFile));
		
			close(pffFile);

			execpff(filename(pffFile));			
		
			// 20120206
			if returnMode = KEYER then
				selectionCode =	errmsg("There were discrepencies. Would you like to return the bag to the keyer?")
								select("Yes",continue,"No",continue);
				
				if selectionCode = 1 then
				
					if moveFilesFromStorageToEntryNoErrors() then
						errmsg("Bag successfully returned to the keyer.");
						resetReturnFormValues();				
						move to RETURN_FORM;
					
					else
						errmsg("Bag could not be returned to the keyer. Accept the bag as incomplete and then reassign to the keyer.");
					
					endif;
				
				endif;
			
			endif;

			errmsg("There are discrepencies. The number of questionnaires on quick count was %d but the number of forms expected was %d. The quick count enumerated total was %d but the number keyed was %d. You must explain the discrepency.",
				visualvalue(RETURN_QUESTIONNAIRES(1)),expectedNumberOfForms,visualvalue(RETURN_ENUMERATED_TOTAL(1)),visualvalue(RETURN_ENUMERATED_TOTAL(2)));
			
			// putnote(strip(DISCREPENCY_NOTES));
			
			do while not length(strip(editnote())) in 1:60
				errmsg("Please describe the discrepencies in 1-60 characters.");
			enddo;
			
		endif;
	
	else
		errmsg("There was an error reading the data file. No statistics will be shown.");
	
	endif;
	

	if not thereAreDiscrepencies and length(strip(DISCREPENCY_NOTES)) then
		selectionCode = errmsg('There are discrepency notes ("%s") but there are no longer discrepencies. Would you like to modify the notes?',strip(DISCREPENCY_NOTES))
			select("Yes",continue,"No",continue);
		
		if selectionCode = 1 then
			// putnote(strip(DISCREPENCY_NOTES));
			str = editnote(); // nothing will happen to str, but CSPro requires that editnote be assigned to something
		endif;
	
	endif;
	
	// 20120209 reference (see above for the change)
			
	RETURN_DISCREPENCIES = getnote(); // get the changes
	DISCREPENCY_NOTES = RETURN_DISCREPENCIES;

	if returnMode = KEYER then
	
		if thereAreDiscrepencies then
			str = "Accept as Complete with Discrepencies";
			
		else
			str = "Accept as Complete";
			
		endif;

		selectionCode = errmsg("What would you like to do with this bag?")
			select(strip(str),continue,"Accept as Incomplete",continue,"Accept and Assign for Verification",continue,"Accept and Approve",continue);
		
		if selectionCode = 1 then
			if thereAreDiscrepencies then
				STATUS = 3;
			else
				STATUS = 2;
			endif;
		
		elseif selectionCode = 2 then
			STATUS = 4;
		
		elseif selectionCode = 3 then
			STATUS = 2;
		
		elseif selectionCode = 4 then
			STATUS = 8;
		
		endif;
		
		FROM_KEYER_DATE = sysdate("YYYYMMDD");
		SUPERVISOR_ID = operatorNumber;
		
		if STATUS = 8 then
			APPROVAL_DATE = sysdate("YYYYMMDD");
		endif;
		
		writecase(ARMENIACONTROL_DICT);
		
		saveChangesToSharedDatabase();
		
		if selectionCode = 3 then
			moveToAssignFormFromVerify(VERIFIER);
		endif;
	

	elseif returnMode = VERIFIER then

		selectionCode = errmsg("What would you like to do with this bag?")
			select("Accept as Complete",continue,"Accept as Incomplete",continue,"Accept and Approve",continue);
		
		if selectionCode = 1 then
			STATUS = 6;
		
		elseif selectionCode = 2 then
			STATUS = 7;
		
		elseif selectionCode = 3 then
			STATUS = 8;
		
		endif;
		
		FROM_VERIFIER_DATE = sysdate("YYYYMMDD");
		SUPERVISOR_ID = operatorNumber;
		
		if STATUS = 8 then
			APPROVAL_DATE = sysdate("YYYYMMDD");
		endif;
		
		writecase(ARMENIACONTROL_DICT);
		
		saveChangesToSharedDatabase();
					
		
	elseif returnMode = APPROVAL then
	
		errmsg("Bag accepted and approved.");

		STATUS = 8;
		SUPERVISOR_ID = operatorNumber;
		APPROVAL_DATE = sysdate("YYYYMMDD");
		
		writecase(ARMENIACONTROL_DICT);
		
		saveChangesToSharedDatabase();


	endif;

	resetReturnFormValues();
	
	move to RETURN_FORM;
	

PROC FIND_FILES_FORM

preproc

	resetFFFormValues(1); // 1 means reset all the values


PROC FF_PORTFEL_CODE

	resetFFFormValues(0); // 0 means only reset the values in the grid

	if not loadcase(ARMENIACONTROL_DICT,FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE) then
		errmsg("Invalid geocode selected. Please reenter or check the master database.");
		reenter;
	endif;
	
	if not calculatePaths() then
		errmsg("No files found for this bag in the primary folders.");
	endif;
	
PROC FF_MENU_SELECTION

	numeric numFilesMoved,fileExists;

	if FF_MENU_SELECTION = 1 then // move files to complete folder
	
		do counter = 1 while counter <= 5
			fileExists = 0;

			toFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,0,counter);
		
			if COMPLETE_FOLDER(counter) = 'X' then
				// do nothing; the file is already in the complete folder
			
			elseif KEYER_FOLDER(counter) = 'X' then
				fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,KEYER_ID,counter);
				fileExists = 1;

			elseif VERIFIER_FOLDER(counter) = 'X' then
				fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,VERIFIER_ID,counter);
				fileExists = 1;
			
			endif;
			
			if fileExists then
				inc(numFilesMoved,filerename(strip(fromFilename),strip(toFilename)));
			endif;		
		
		enddo;
		
		errmsg("%d files moved to complete folder.",numFilesMoved);


	elseif FF_MENU_SELECTION = 2 then // move files to keyer folder
	
		if KEYER_ID = notappl then
			errmsg("No keyer was assigned to this bag.");
			reenter;
		endif;
	
		do counter = 1 while counter <= 5
			fileExists = 0;

			toFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,KEYER_ID,counter);
		
			if COMPLETE_FOLDER(counter) = 'X' then
				fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,0,counter);
				fileExists = 1;
			
			elseif KEYER_FOLDER(counter) = 'X' then
				// do nothing; the file is already in the keyer folder

			elseif VERIFIER_FOLDER(counter) = 'X' then
				fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,VERIFIER_ID,counter);
				fileExists = 1;
			
			endif;

			if fileExists then
				inc(numFilesMoved,filerename(strip(fromFilename),strip(toFilename)));
			endif;		
		
		enddo;
		
		errmsg("%d files moved to keyer folder.",numFilesMoved);


	elseif FF_MENU_SELECTION = 3 then // move files to verifier folder
	
		if VERIFIER_ID = notappl then
			errmsg("No verifier was assigned to this bag.");
			reenter;
		endif;
	
		do counter = 1 while counter <= 5
			fileExists = 0;

			toFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,VERIFIER_ID,counter);
		
			if COMPLETE_FOLDER(counter) = 'X' then
				fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,0,counter);
				fileExists = 1;
			
			elseif KEYER_FOLDER(counter) = 'X' then
				fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,KEYER_ID,counter);
				fileExists = 1;

			elseif VERIFIER_FOLDER(counter) = 'X' then
				// do nothing; the file is already in the verifier folder
			
			endif;
			
			if fileExists then
				inc(numFilesMoved,filerename(strip(fromFilename),strip(toFilename)));
			endif;		
		
		enddo;
		
		errmsg("%d files moved to verifier folder.",numFilesMoved);
	

	elseif FF_MENU_SELECTION = 4 then
		move to FF_OPERATOR_CODE;


	elseif FF_MENU_SELECTION = 5 then
		putnote(strip(findFilesInfo));
		str = editnote();
		reenter;
	

	elseif FF_MENU_SELECTION = 9 then // search all operator folders and move to complete
	
		do counter = 1 while counter <= 5
			fileExists = 0;

			if not COMPLETE_FOLDER(counter) = 'X' then
				toFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,0,counter);
				
				numeric operator;
			
				do operator = 1 while operator <= maxNumberOperators
					fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,operator,counter);
					inc(numFilesMoved,filerename(strip(fromFilename),strip(toFilename)));
				enddo;
			
			endif;
		
		enddo;
		
		errmsg("%d files moved to complete folder.",numFilesMoved);


	else
		errmsg("Invalid selection. Please reenter.");
		reenter;
	
	endif;
	
	
	resetFFFormValues(0); // 0 means only reset the values in the grid		
	calculatePaths();
	reenter;


PROC FF_OPERATOR_CODE

	numeric numFilesMoved,fileExists;

	do counter = 1 while counter <= 5
		fileExists = 0;

		toFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,FF_OPERATOR_CODE,counter);
	
		if COMPLETE_FOLDER(counter) = 'X' then
			fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,0,counter);
			fileExists = 1;
		
		elseif KEYER_FOLDER(counter) = 'X' then
			fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,KEYER_ID,counter);
			fileExists = 1;

		elseif VERIFIER_FOLDER(counter) = 'X' then
			fromFilename = calculateFilenameForMove(FF_MARZ_CODE,FF_REGION_CODE,FF_HAMAYNK_CODE,FF_BNAKAVAJR_CODE,FF_PORTFEL_CODE,VERIFIER_ID,counter);
			fileExists = 1;
		
		endif;

		if fileExists then
			inc(numFilesMoved,filerename(strip(fromFilename),strip(toFilename)));
		endif;		
	
	enddo;
	
	errmsg("%d files moved to oper%d folder.",numFilesMoved,FF_OPERATOR_CODE);
	
	resetFFFormValues(0); // 0 means only reset the values in the grid		
	calculatePaths();

	FF_OPERATOR_CODE = notappl;
	reenter FF_MENU_SELECTION;
	
	
PROC VIEW_WORK_FORM

preproc

	resetViewWorkFormValues(1); // 1 means reset all the values
	populateWorkFormValues(0); // without a filter
	

PROC VW_MENU_SELECTION

	if VW_MENU_SELECTION = 0 then
		VW_MENU_SELECTION = notappl;
		move to VIEW_FILTER;

	elseif VW_MENU_SELECTION <= numRowsInWorkGrid then
	
		// the action depends on the status type (remembering that these are recoded status types)
		numeric thisStatus = visualvalue(VW_BAG_STATUS(VW_MENU_SELECTION));

		str = maketext("What would you like to do with bag %03d%d%03d%d%03d?",visualvalue(VW_MARZ_CODE(VW_MENU_SELECTION)),
				visualvalue(VW_REGION_CODE(VW_MENU_SELECTION)),visualvalue(VW_HAMAYNK_CODE(VW_MENU_SELECTION)),
				visualvalue(VW_BNAKAVAJR_CODE(VW_MENU_SELECTION)),visualvalue(VW_PORTFEL_CODE(VW_MENU_SELECTION)));
		
		if thisStatus = 1 then
			selectionCode = errmsg(strip(str)) select("Check in bag",continue,"Cancel",VW_MENU_SELECTION);
			moveToReturnFormFromWork(KEYER,VW_MENU_SELECTION);
			
		elseif thisStatus = 2 then
			selectionCode = errmsg(strip(str)) select("Check out for keying",continue,"Cancel",VW_MENU_SELECTION);
			moveToAssignFormFromWork(KEYER,VW_MENU_SELECTION);

		elseif thisStatus = 3 then
			selectionCode = errmsg(strip(str)) select("Check out bag for verification",continue,"Approve bag",continue,"Cancel",VW_MENU_SELECTION);
			
			if selectionCode = 1 then	moveToAssignFormFromWork(VERIFIER,VW_MENU_SELECTION);
			else						moveToReturnFormFromWork(APPROVAL,VW_MENU_SELECTION);
			endif;

		elseif thisStatus = 4 then
			selectionCode = errmsg(strip(str)) select("Check in bag",continue,"Cancel",VW_MENU_SELECTION);
			moveToReturnFormFromWork(VERIFIER,VW_MENU_SELECTION);

		elseif thisStatus = 5 then
			selectionCode = errmsg(strip(str)) select("Check out bag for verification",continue,"Approve bag",continue,"Cancel",VW_MENU_SELECTION);

			if selectionCode = 1 then	moveToAssignFormFromWork(VERIFIER,VW_MENU_SELECTION);
			else						moveToReturnFormFromWork(APPROVAL,VW_MENU_SELECTION);
			endif;

		elseif thisStatus = 6 then
			selectionCode = errmsg(strip(str)) select("Approve bag",continue,"Cancel",VW_MENU_SELECTION);
			moveToReturnFormFromWork(APPROVAL,VW_MENU_SELECTION);
		
		endif;
	
	else
		errmsg("Please choose a valid bag.");
		reenter;
		
	endif;
	
		
PROC VIEW_FILTER

	if not VIEW_FILTER in 1:6 then
		errmsg("Select a valid view filter.");
		reenter;
	
	else
		resetViewWorkFormValues(0); // reset only the grid
		populateWorkFormValues(VIEW_FILTER);
		move to VW_MENU_SELECTION;
	
	endif;
		

PROC MODIFY_DATABASE_FORM

preproc

	// allow blanks throughout this form
	set behavior(ARMENIACONTROL_DICT) canenter(notappl) on (noconfirm);


PROC DISCREPENCY_NOTES

	saveChangesFromExternalForm = errmsg("Do you want to save these changes?") select("Yes",continue,"No",continue);

